// Listing 11.3 Wywoywane konstruktory i destruktory
#include <iostream>
using namespace std;
enum BREED { GOLDEN, CAIRN, DANDIE, SHETLAND, DOBERMAN, LAB };

class Mammal
{
  public:
    // konstruktory
    Mammal();
    ~Mammal();

    // akcesory
    int GetAge() const { return itsAge; }
    void SetAge(int age) { itsAge = age; }
    int GetWeight() const { return itsWeight; }
    void SetWeight(int weight) { itsWeight = weight; }

    // inne metody
    void Speak()const { cout << "Dzwiek ssaka!\n"; }
    void Sleep()const { cout << "Ciiiicho. Wlasnie spie.\n"; }

  protected:
    int itsAge;
    int itsWeight;
};

class Dog : public Mammal
{
  public:

    // konstruktory
    Dog();
    ~Dog();

    // akcesory
    BREED GetBreed() const { return itsBreed; }
    void SetBreed(BREED breed) { itsBreed = breed; }

    // inne metody
    void WagTail() const { cout << "Macham ogonkiem...\n"; }
    void BegForFood() const { cout << "Prosze o jedzenie...\n"; }

  private:
    BREED itsBreed;
};

Mammal::Mammal():
itsAge(3),
itsWeight(5)
{
    std::cout << "Konstruktor klasy Mammal..." << endl;
}

Mammal::~Mammal()
{
    std::cout << "Destruktor klasy Mammal..." << endl;
}

Dog::Dog():
itsBreed(GOLDEN)
{
    std::cout << "Konstruktor klasy Dog..." << endl;
}

Dog::~Dog()
{
    std::cout << "Destruktor klasy Dog..." << endl;
}
int main()
{
    Dog Fido;
    Fido.Speak();
    Fido.WagTail();
    std::cout << "Fido ma " << Fido.GetAge() << " lat(a)" << endl;
    return 0;
}
